/*
 * Copyright (C) 2012-2021 SonarSource SA - mailto:info AT sonarsource DOT com
 * This code is released under [MIT No Attribution](https://opensource.org/licenses/MIT-0) license.
 */
package org.sonar.samples.java.checks;

import org.junit.jupiter.api.Test;
import org.sonar.java.checks.verifier.CheckVerifier;

/**
 * This class is the test of the AvoidMethodDeclarationRule.
 * Checks by running it against a minimal valid file.
 */
class AvoidMethodDeclarationRuleTest {

  @Test
  void detected() {
    // Verifies that the check will raise the adequate issues with the expected message.
    // In the test file, lines which should raise an issue have been commented out
    // by using the following syntax: "// Noncompliant {{EXPECTED_MESSAGE}}"
    CheckVerifier.newVerifier()
      .onFile("src/test/files/AvoidMethodDeclarationRule.java")
      .withCheck(new AvoidMethodDeclarationRule())
      .verifyIssues();
  }
}
